; DO NOT LIST THIS HUGE CODE! 
.NOLIST

; To keep directries easier to read these files have been merged to one

; START FILE ASM86.H

;====================================================================
;These are common zshell and usgard calls that are known on the TI-86
;If possible, use the call that is commented next to the one you want
;====================================================================

;====================================================================
;START OF SPECIAL USERDEFINED ROMCALLS
;====================================================================

_getcode        =            4068h            ; Get scancode, but much faster than _GETKEY.

;====================================================================
; START OF TI86UNDC.INC, AS FOUND IN \TISCO\BIN\
; SOME HANDY (UNDOCUMENTED) ROMCALLS & ADRESSES SCRAPPED TOGETHER BY
;	NSJ aka Viriato 1998
;====================================================================

_winTop             =         0D13Dh	; first homescreen row
_winBtm             =         0D13Eh	; last homescreen row
_winLeftEdge        =         0D13Fh
_winLeft            =         0D140h
_winAbove           =         0D142h
_winRow             =         0D144h
_winCol             =         0D146h

_clrText            =         4AB5h   ;(set up text shadow & copy to cmd shadow)
;$4AB9   $3AD7   _setText (set up text shadow)
;$4ABD   $3AD1   _setText_stay - set up text shadow ($28f8, see above)
;$4AC0   $3ADD   _clrText_stay - copy text shadow to screen ($28f8)
_cpyText            =         4AC3h   ; (copy text shadow->screen)

;
;   TI-86 undocumented ROM calls
;
_dispAHL		=	4A33h
_dispOP1		=	515Bh
_calcOff		=	4101h	; Turn off calc.
_pause           =    4D43h
_homeup          =    4A95h
_cursorOn        =    4994h
_cursorOff       =    498Ch
__SetUpperAlpha   =    407Ch	; set upper case alpha lock
__ClearUpperAlpha =    4074h	; clear upper case alphalock
_enough_mem      =    46DBh	; hl = mem needed; CF = 1 if not enough mem
_ldhlind         =    4010h	; hl = (hl)
_inc_ptr_ade     =    45EFh	; ade++
_ex_ahl_bde      =    45F3h	; ex   ahl, bde
_ld_ade_hl       =    45F7h	; ade = (hl), hl += 3
_ld_bde_hl       =    45FBh	; bde = (hl), hl += 3
_ld_ahl_hl       =    45FFh	; ahl = (hl)
_ld_hl_ade       =    4603h	; (hl) = ade, hl += 3
_ld_hl_bde       =    4607h	; (hl) = bde, hl += 3
_get_word_ahl    =    521Dh	; de = (ahl), ahl += 2
_set_word_ahl    =    521Dh	; (ahl) = de, ahl += 2
_add_ahl_2       =    4C3Fh	; ahl += 2
_cp_ahl_bde      =    46C7h	; Compares ahl and bde and sets Z flag
_ckop1pos        =    450Fh    ; OP1 >= 0  =>  ZF = 1
_ckop1fp0        =    449Bh    ; OP1 == 0  =>  ZF = 1
_negOP1          =    5494h    ; OP1 = -OP1
_pushOP1         =    4813h
_popOP1          =    47B7h
_abs             =    4517h    ; a = sign(OP1); OP1 = abs(OP1)
_HLdivA          =    4044h
__strlen         =    4957h    ; bc = strlen(hl). Preserves all.
__strcpy         =    495Bh    ; strcpy(de, hl). Destroys A.
__strcat         =    495Fh    ; strcat(de, hl). Destroys A.
__strcmp	= 4963h    ; strcmp(hl, de), strings with length bytes.
                                 ; Destroys A.
;====================================================================
;	END OF TI86UNDC.INC
;====================================================================


MUL_HL		= $4547

CP_HL_DE	= $403C
LD_HL_MHL	= $4010
GET_KEY		= $5371
UNPACK_HL	= $4044

D_HL_DECI	= $4a33

BUSY_OFF	= $4ab1			;_runindoff
BUSY_ON		= $4aad			;_runindicon
D_ZT_STR	= $4a37			;_puts
D_LT_STR	= $4a3b			;_putps
TX_CHARPUT	= $4a2b			;_putc
D_ZM_STR	= $4aa5			;_vputs
D_LM_STR	= $4aa9			;_vputsn
M_CHARPUT	= $4aa1			;_vputmap
CLEARLCD	= $4a7e			;_clrLCD

;====================================================================
;END OF SPECIAL USERDEFINED ROMCALLS
;====================================================================

;========================================================
;These are memory addresses common for zshell programming
;If possible, use the one on the right
;========================================================

CONTRAST = $c008			
CURSOR_ROW = $c00f			;_curRow
CURSOR_COL = $c010			;_curCol
BUSY_COUNTER = $c087 
BUSY_BITMAP	= $c088
TEXT_MEM = $c0f9			;_textShadow
CURSOR_X = $c37c			;_penCol
CURSOR_Y = $c37d			;_penRow
GRAPH_MEM = $c9fa			;_plotSScreen
TEXT_MEM2 = $cfab			;_cmdShadow
VAT_END = $d298
VAT_START = $8000
VIDEO_MEM = $fc00

;==================================================================
;all the keys are used with <call GET_KEY>, not TI's <call _getkey>
;==================================================================
K_NOKEY       =$00    ;No key
K_DOWN        =$01    ;Down
K_LEFT        =$02    ;Left
K_RIGHT       =$03    ;Right
K_UP          =$04    ;Up
K_ENTER       =$09    ;Enter
K_PLUS        =$0A    ;+                      X
K_MINUS       =$0B    ;-                      T
K_STAR        =$0C    ;*                      O
K_SLASH       =$0D    ;/                      J
K_RAISE       =$0E    ;^                      E
K_CLEAR       =$0F    ;Clear
K_SIGN        =$11    ;(-)                    Space
K_3           =$12    ;3                      W
K_6           =$13    ;6                      S
K_9           =$14    ;9                      N
K_RIGHTPAR    =$15    ;)                      I
K_TAN         =$16    ;Tan                    D
K_CUSTOM      =$17    ;Custom
K_DOT         =$19    ;.                      Z
K_2           =$1A    ;2                      V
K_5           =$1B    ;5                      R
K_8           =$1C    ;8                      M
K_LEFTPAR     =$1D    ;(                      H
K_COS         =$1E    ;Cos                    C
K_PRGM        =$1F    ;Prgm
K_DEL         =$20    ;Del
K_0           =$21    ;0                      Y
K_1           =$22    ;1                      U
K_4           =$23    ;4                      Q
K_7           =$24    ;7                      L
K_EE          =$25    ;EE                     G
K_SIN         =$26    ;Sin                    B
K_TABLE       =$27    ;Table		  ;Used to be Stat on the TI-85, now K_TABLE
K_XVAR        =$28    ;x-Var                  x
K_ON          =$29    ;On
K_STO         =$2A    ;Sto                    =
K_COMMA       =$2B    ;,                      P
K_SQUARE      =$2C    ;x^2                    K
K_LN          =$2D    ;Ln                     F
K_LOG         =$2E    ;Log                    A
K_GRAPH       =$2F    ;Graph
K_ALPHA       =$30    ;Alpha
K_F5          =$31    ;F5
K_F4          =$32    ;F4
K_F3          =$33    ;F3
K_F2          =$34    ;F2
K_F1          =$35    ;F1
K_SECOND      =$36    ;2nd
K_EXIT        =$37    ;EXIT
K_MORE        =$38    ;MORE

; START FILE TI86ABS.INC

;
;
;       TI-86 'Paged Ram' Support routines
;
;

;
;       some ram =ates
;
_ABS_SRC_ADDR      =         0C392h   ; 3 byte ABS address pointer
_ABS_DEST_ADDR     =         0C395h   ; 3 byte ABS address pointer
_MM_NUM_BYTES      =         0C398h   ; 3 byte block move counter
;

;
;
;       'Block' Move Support Routines
;
;

;
; ahl -> (_abs_src_addr)
;
_SET_ABS_SRC_ADDR                =            4647h

;
; ahl -> (_abs_dest_addr)
;
_SET_ABS_DEST_ADDR               =            5285h

;
; ahl -> (_mm_num_bytes)
;
_SET_MM_NUM_BYTES                =            464Fh


;
;       This routine mimmicks the Z80's LDIR instruction.
;
;
; INPUTS       - abs_src_addr, abs_dest_addr, mm_num_bytes
;                Source Address, Destination Address, and # of bytes,
;                all in 24-bit form.
; OUTPUTS      - abs_src_addr, abs_dest_addr, mm_num_bytes
;                Modified exactly as HL, DE, and BC are after LDIR
;
;  moves (_mm_num_bytes) bytes starting @ (_abs_src_addr) to (_abs_dest_addr)
;  incrementing the src/dest pointer after each byte moved
;
_mm_ldir           =         52EDh

;
;
;       This routine mimmicks the Z80's LDIR instruction.
;
;
; INPUTS       - abs_src_addr, abs_dest_addr, mm_num_bytes
;                Source Address, Destination Address, and # of bytes,
;                all in 24-bit form.
; OUTPUTS      - abs_src_addr, abs_dest_addr, mm_num_bytes
;                Modified exactly as HL, DE, and BC are after LDIR
;
;  moves (_mm_num_bytes) bytes starting @ (_abs_src_addr) to (_abs_dest_addr)
;  decrementing the src/dest pointer after each byte moved
;
_mm_lddr           =         52F1h
;

;
;  ahl -> (_abs_src_addr). move 10 bytes @ (_abs_src_addr) -> OP1
;
_ABS_MOV10TOOP1    =         5235h

;
;  move 10 bytes @ (_abs_src_addr) -> OP1
;
_ABS_MOV10TOOP1_noset   =    5239h

;
; ahl -> (_abs_dest_addr).move 10 bytes from (_abs_src_addr)->(_abs_dest_addr)
;
_ABS_MOV10B_SET_D  =         523Dh

;
; move 10 bytes from (_abs_src_addr) -> (_abs_dest_addr)
;
_ABS_MOV10B        =         5249h

;
; ahl -> (_abs_dest_addr). move 10 bytes from OP1 -> (_abs_dest_addr)
;
_ABS_MOVFROP1_SET_D    =     5241h

;
; move 10 bytes from OP1 -> (_abs_dest_addr)
;
_ABS_MOVFROP1      =         5245h

;
;
;       Misc support
;
;
_inc_ptr_ahl    =    4637h    ; ahl = ahl + 1
_dec_ptr_ahl    =    463Bh    ; ahl = ahl - 1
_inc_ptr_bde    =    463Fh    ; bde = bde + 1 , ahl & status intact
_dec_ptr_dbe    =    4643h    ; bde = bde - 1 , ahl & status intact
_dec_ptr_ade    =    46BFh    ; ade = ade - 1


;
; decode ABS ahl and load the RAM page and set hl = offset, (hl) = (ABS ahl)
;
_load_ram_ahl   =    462Fh

_GETB_AHL       =    46C3h ; acc = (ABS ahl), hl = asic address now


_RAM_PAGE_1     =    47E3h ; load RAM page 1, FPS page
_RAM_PAGE_7     =    47F3h ; load RAM page 7, symbol table page

;
;  write c -> (ABS ahl), ahl = ahl + 1, still ABS address
;
_writeb_inc_ahl    =     5567h

; START FILE TI86OPS.INC

;
;
;       Support routines for OP1 - OP6 registers
;
;
;
_OP3TOOP4       =            4203h            ; op3 -> op4, 11 bytes moved
_OP1TOOP4       =            4207h
_OP2TOOP4       =            420Bh
_OP4TOOP2       =            4213h
_OP4TOOP3       =            4217h
_OP3TOOP2       =            421Bh
_OP1TOOP3       =            421Fh
_OP5TOOP2       =            4227h
_OP5TOOP6       =            422Bh
_OP5TOOP4       =            422Fh
_OP1TOOP2       =            4233h
_OP6TOOP2       =            423Bh
_OP6TOOP1       =            423Fh
_OP4TOOP1       =            4243h
_OP5TOOP1       =            4247h
_OP3TOOP1       =            424Bh
_OP4TOOP5       =            424Fh
_OP3TOOP5       =            4253h
_OP2TOOP5       =            4257h
_OP2TOOP6       =            425Fh
_OP1TOOP6       =            4263h
_OP1TOOP5       =            426Bh
_OP2TOOP1       =            426Fh
;
_MOV10B         =            427Bh            ; move 10 bytes
_MOV18          =            427Fh
_mov9b          =            4283h
_MOV8B          =            4287h
_MOV7B          =            428Bh
_MOV6B          =            4293h
_MOV5B          =            4297h
_MOV4B          =            429Bh
_MOV3B          =            429Fh
_MOV2B          =            42A3h
_OP2TOOP3       =            42CBh
_OP4TOOP6       =            42D3h
_MOV10TOOP1     =            42D7h     ; 10 bytes @ (hl) -> op1 non banked
_MOV10TOOP2     =            42DFh     ; 10 bytes @ (hl) -> op2 non banked
_MOVFROP1       =            42E3h     ; 10 bytes @ op1 -> (de) non banked
;
_OP4SET1        =            42E7h     ; op4 = floatin point 1
_OP3SET1        =            42EBh
_OP2SET8        =            42EFh
_OP2SET5        =            42F7h
_OP2SET4        =            42FBh
_OP2SET3        =            4303h
_op1set1        =            430Fh
_OP1SET4        =            4313h
_OP1SET3        =            4317h
_OP3SET2        =            431Bh
_OP1SET2        =            431Fh
_OP2SET2        =            4323h
_OP2SET1        =            432Fh
_OP4SET0        =            4353h
_OP3SET0        =            4357h
_OP2SET0        =            435Bh
_OP1SET0        =            435Fh
;
_ZEROOP1M       =            4367h            ; mantissa op1 = 0's
_ZEROOP1        =            436Bh            ; 11 bytes op1 = 0
_ZEROOP2        =            436Fh
_ZEROOP3        =            4373h

; START FILE TI86MATH.INC 

;
;
;       Floating Point Math entry points for TI-86
;
;
_INTGR          =            5468h            ; op1 = intgr(op1)
_MINUS1         =            5470h            ; op1 = op1 - 1
_FPSUB          =            5474h            ; op1 = op1-op2
_FPADD          =            5478h            ; op1 = op1+op2
_TIMESPT5       =            5484h            ; op1 = .5 * op1
_FPSQUARE       =            5488h            ; op1 = op1^2
_FPMULT         =            548Ch            ; op1 = op1*op2
_FRAC           =            549Ch            ; op1 = frac(op1)
_FPRECIP        =            54A4h            ; op1 = 1/op1
_FPDIV          =            54A8h            ; op1 = op1/op2
;
_SQROOT         =            54ACh     ; op1 = sqrt(op1), neg #'s error
_SQROOTP        =            54B0h     ; op1 = sqrt(op1), neg #'s -> complex
;
_RNDGUARD       =            54BCh            ; round op1 to 12 digits
;
_LNX            =            54C4h     ; op1 = ln(op1), neg #'s error
_LNXP           =            54C8h     ; op1 = ln(op1), neg #'s -> complex
;
_LOGXP          =            54CCh     ; op1 = log(op1), neg #'s error
_LOGX           =            54D0h     ; op1 = log(op1), neg #'s -> complex
;
_ETOX           =            54D4h            ; op1 = e^op1
_TENX           =            54D8h            ; op1 = 10^op1
;
_SIN            =            54E0h            ; op1 = sin(op1), current mode
_COS            =            54E4h            ; op1 = cos(op1), current mode
_TAN            =            54E8h            ; op1 = tan(op1), current mode
;
_TANH           =            54F0h            ; op1= hyp tan(op1)
_COSH           =            54F4h            ; op1= hyp cos(op1)
_SINH           =            54F8h            ; op1= hyp sin(op1)
;
_ACOS           =            5508h   ; op1 = inv cos(op1), no complex results
_ACOSP          =            550Ch   ; op1 = inv cos(op1), complex results ok
;
_ATAN           =            5510h            ; op1 = inv tan(op1)
_ASIN           =            5514h            ; op1 = inv sin(op1)
;
_ATANH          =            551Ch            ; op1 = inv hyp Tan(op1)
_ASINH          =            5524h            ; op1 = inv hyp sin(op1)
_ACOSH          =            5528h            ; op1 = inv hyp cos(op1)
;
_YTOX           =            5538h            ; op1 = op1^op2

; START FILE TI86ASM.INC

;
;
;       some helpful system routine addresses
;
;
;       For now refer to existing TI-85 or TI-83 documentation
;       from the WEB.
;
;
_clrLCD                          =            4A7Eh
_clrScrn                         =            4A82h
_putmap                          =            4A27h
_putc                            =            4A2Bh
_puts                            =            4A37h
_putps                           =            4A3Bh
_vputmap                         =            4AA1h
_vputs                           =            4AA5h
_vputsn                          =            4AA9h
_GRBUFCPY                        =            4E39h
_ILine                           =            4E51h
_IPoint                          =            4E59h
_PDspGrph                        =            4D6Fh
_CLine                           =            51E9h
_getkey                          =            55AAh
_RANDOM                          =            55DAh
_newline                         =            4A5Fh
_runindicoff                     =            4AB1h
_runindicon                      =            4AADh
;
;
;       start address for all ASM programs
;
;
_asm_exec_ram             =         0D748h
;
;
;       op1 to op6 ram =ates
;
;
_OP1                      =         0C089h
_OP1EXPM                  =         0C08Ah
_OP1EXPL                  =         0C08Bh
_OP1M                     =         0C08Ch
_OP1EXT                   =         0C093h
_OP2                      =         0C094h
_OP2EXPM                  =         0C095h
_OP2EXPL                  =         0C096h
_OP2M                     =         0C097h
_OP2EXT                   =         0C09Eh
_OP3                      =         0C09Fh
_OP3EXPM                  =         0C0A0h
_OP3EXPL                  =         0C0A1h
_OP3M                     =         0C0A2h
_OP3EXT                   =         0C0A9h
_OP4                      =         0C0AAh
_OP4EXPM                  =         0C0ABh
_OP4EXPL                  =         0C0ACh
_OP4M                     =         0C0ADh
_OP4EXT                   =         0C0B4h
_OP5                      =         0C0B5h
_OP5EXPM                  =         0C0B6h
_OP5EXPL                  =         0C0B7h
_OP5M                     =         0C0B8h
_OP5EXT                   =         0C0BFh
_OP6                      =         0C0C0h
_OP6EXPM                  =         0C0C1h
_OP6EXPL                  =         0C0C2h
_OP6M                     =         0C0C3h
_OP6EXT                   =         0C0CAh
;
;
;       screen shadow ram =ates
;
;
_textShadow               =         0C0F9h
_cmdShadow                =         0CFABh
_plotSScreen              =         0C9FAh
;
;
;       display cursor ram =ates
;
;
_curRow                   =         0C00Fh
_curCol                   =         0C010h
_penCol                   =         0C37Ch
_penRow                   =         0C37Dh
;
;
;       link port =ates
;
;
BPort           =     7               ;4-bit I/O
D0LD1L      =          0FCh
D0LD1H      =          0D4h
D0HD1L      =          0E8h
D0HD1H      =          0C0h
;
;
;
;       character font =ates
;
;
;
Lbinary = 001h
Loctal  = 002h
Ldecimal    = 003h
Lhexadecimal    = 004h
Lconvert    = 005h
LsqUp   = 006h
LsqDown = 007h
Lintegral   = 008h
Lcross  = 009h
LhexA   = 00Ah
LhexB   = 00Bh
LhexC   = 00Ch
LhexD   = 00Dh
LhexE   = 00Eh
LhexF   = 00Fh
Lroot   = 010h
Linverse    = 011h
Lsquare = 012h
Langle  = 013h
Ldegree = 014h
Lradian = 015h
Ltranspose  = 016h
LLE = 017h
LNE = 018h
LGE = 019h
Lneg    = 01Ah
Lexponent   = 01Bh
Lstore  = 01Ch
Lten    = 01Dh
LupArrow    = 01Eh
LdownArrow  = 01Fh
Lspace  = 020h
Lexclam = 021h
Lquote  = 022h
Lpound  = 023h
Ldollar = 024h
Lpercent    = 025h
Lampersand  = 026h
Lapostrophe = 027h
LlParen = 028h
LrParen = 029h
Lasterisk   = 02Ah
LplusSign   = 02Bh
Lcomma  = 02Ch
Ldash   = 02Dh
Lperiod = 02Eh
Lslash  = 02Fh
L0  = 030h
L1  = 031h
L2  = 032h
L3  = 033h
L4  = 034h
L5  = 035h
L6  = 036h
L7  = 037h
L8  = 038h
L9  = 039h
Lcolon  = 03Ah
Lsemicolon  = 03Bh
LLT = 03Ch
LEQ = 03Dh
LGT = 03Eh
Lquestion   = 03Fh
LatSign = 040h
LcapA   = 041h
LcapB   = 042h
LcapC   = 043h
LcapD   = 044h
LcapE   = 045h
LcapF   = 046h
LcapG   = 047h
LcapH   = 048h
LcapI   = 049h
LcapJ   = 04Ah
LcapK   = 04Bh
LcapL   = 04Ch
LcapM   = 04Dh
LcapN   = 04Eh
LcapO   = 04Fh
LcapP   = 050h
LcapQ   = 051h
LcapR   = 052h
LcapS   = 053h
LcapT   = 054h
LcapU   = 055h
LcapV   = 056h
LcapW   = 057h
LcapX   = 058h
LcapY   = 059h
LcapZ   = 05Ah
LlBrack = 05Bh
Lbackslash  = 05Ch
LrBrack = 05Dh
Lcaret  = 05Eh
Lunderscore = 05Fh
Lbackquote  = 060h
La  = 061h
Lb  = 062h
Lc  = 063h
Ld  = 064h
Le  = 065h
Lf  = 066h
Lg  = 067h
Lh  = 068h
Li  = 069h
Lj  = 06Ah
Lk  = 06Bh
Ll  = 06Ch
Lm  = 06Dh
Ln  = 06Eh
Lo  = 06Fh
Lp  = 070h
Lq  = 071h
Lr  = 072h
Ls  = 073h
Lt  = 074h
Lu  = 075h
Lv  = 076h
Lw  = 077h
Lx  = 078h
Ly  = 079h
Lz  = 07Ah
LlBrace = 07Bh
Lbar    = 07Ch
LrBrace = 07Dh
Ltilde  = 07Eh
LinvEQ  = 07Fh
Lsub0   = 080h
Lsub1   = 081h
Lsub2   = 082h
Lsub3   = 083h
Lsub4   = 084h
Lsub5   = 085h
Lsub6   = 086h
Lsub7   = 087h
Lsub8   = 088h
Lsub9   = 089h
LcapAAcute  = 08Ah
LcapAGrave  = 08Bh
LcapACaret  = 08Ch
LcapADier   = 08Dh
LaAcute = 08Eh
LaGrave = 08Fh
LaCaret = 090h
LaDier  = 091h
LcapEAcute  = 092h
LcapEGrave  = 093h
LcapECaret  = 094h
LcapEDier   = 095h
LeAcute = 096h
LeGrave = 097h
LeCaret = 098h
LeDier  = 099h
LcapIAcute  = 09Ah
LcapIGrave  = 09Bh
LcapICaret  = 09Ch
LcapIDier   = 09Dh
LiAcute = 09Eh
LiGrave = 09Fh
LiCaret = 0A0h
LiDier  = 0A1h
LcapOAcute  = 0A2h
LcapOGrave  = 0A3h
LcapOCaret  = 0A4h
LcapODier   = 0A5h
LoAcute = 0A6h
LoGrave = 0A7h
LoCaret = 0A8h
LoDier  = 0A9h
LcapUAcute  = 0AAh
LcapUGrave  = 0ABh
LcapUCaret  = 0ACh
LcapUDier   = 0ADh
LuAcute = 0AEh
LuGrave = 0AFh
LuCaret = 0B0h
LuDier  = 0B1h
LcapCCed    = 0B2h
LcCed   = 0B3h
LcapNTilde  = 0B4h
LnTilde = 0B5h
Laccent = 0B6h
Lgrave  = 0B7h
Ldieresis   = 0B8h
LquesDown   = 0B9h
LexclamDown = 0BAh
Lalpha  = 0BBh
Lbeta   = 0BCh
Lgamma  = 0BDh
LcapDelta   = 0BEh
Ldelta  = 0BFh
Lepsilon    = 0C0h
Ltheta  = 0C1h
Llambda = 0C2h
Lmu = 0C3h
Lpi = 0C4h
Lrho    = 0C5h
LcapSigma   = 0C6h
Lsigma  = 0C7h
Ltau    = 0C8h
Lphi    = 0C9h
LcapOmega   = 0CAh
LxMean  = 0CBh
LyMean  = 0CCh
LsupX   = 0CDh
Lellipsis   = 0CEh
Lleft   = 0CFh
Lblock  = 0D0h
Lper    = 0D1h
Lhyphen = 0D2h
Larea   = 0D3h
Ltemp   = 0D4h
Lcube   = 0D5h
Lenter  = 0D6h
LblockArrow     =     0D7h
;
;
;       'getkey' =ates
;
;
kRight  = 001h
kLeft   = 002h
kUp = 003h
kDown   = 004h
kColon  = 005h
kEnter  = 006h
kExit   = 007h
kClear  = 008h
kDel    = 009h
kIns    = 00Ah
kNext   = 00Bh
kAdd    = 00Ch
kSub    = 00Dh
kMul    = 00Eh
kDiv    = 00Fh
kExpon  = 010h
kLParen = 011h
kRParen = 012h
kLBrack = 013h
kRBrack = 014h
kEqual  = 015h
kStore  = 016h
kRecall = 017h
kComma  = 018h
kAng    = 019h
kChs    = 01Ah
kDecPnt = 01Bh
k0  = 01Ch
k1  = 01Dh
k2  = 01Eh
k3  = 01Fh
k4  = 020h
k5  = 021h
k6  = 022h
k7  = 023h
k8  = 024h
k9  = 025h
kEE = 026h
kSpace  = 027h
kCapA   = 028h
kCapB   = 029h
kCapC   = 02Ah
kCapD   = 02Bh
kCapE   = 02Ch
kCapF   = 02Dh
kCapG   = 02Eh
kCapH   = 02Fh
kCapI   = 030h
kCapJ   = 031h
kCapK   = 032h
kCapL   = 033h
kCapM   = 034h
kCapN   = 035h
kCapO   = 036h
kCapP   = 037h
kCapQ   = 038h
kCapR   = 039h
kCapS   = 03Ah
kCapT   = 03Bh
kCapU   = 03Ch
kCapV   = 03Dh
kCapW   = 03Eh
kCapX   = 03Fh
kCapY   = 040h
kCapZ   = 041h
ka  = 042h
kb  = 043h
kc  = 044h
kd  = 045h
ke  = 046h
kf  = 047h
kg  = 048h
kh  = 049h
ki  = 04Ah
kj  = 04Bh
kk  = 04Ch
kl  = 04Dh
km  = 04Eh
kn  = 04Fh
ko  = 050h
kp  = 051h
kq  = 052h
kr  = 053h
ks  = 054h
kt  = 055h
ku  = 056h
kv  = 057h
kw  = 058h
kx  = 059h
ky  = 05Ah
kz  = 05Bh
kVarx   = 05Ch
kAns    = 05Dh
kPi = 05Eh
kInv    = 05Fh
kSin    = 060h
kASin   = 061h
kCos    = 062h
kACos   = 063h
kTan    = 064h
kATan   = 065h
kSquare = 066h
kSqrt   = 067h
kLn = 068h
kExp    = 069h
kLog    = 06Ah
kALog   = 06Bh
kMath   = 06Ch
kCplx   = 06Dh
kString = 06Eh
kTest   = 06Fh
kConv   = 070h
kChar   = 071h
kBase   = 072h
kCustom = 073h
kVars   = 074h
kCatalog    = 075h
kQuit   = 076h
kLastEnt    = 077h
kLinkIO = 078h
kMem    = 079h
kList   = 07Ah
kVector = 07Bh
kConst  = 07Ch
kMatrix = 07Dh
kPoly   = 07Eh
kSimult = 07Fh
kStat   = 080h
kGrMenu = 081h
kMode   = 082h
kPrgm   = 083h
kCalcu  = 084h
kSolver = 085h
;
kTable  = 086h        ; new key added for LEO
;
kBOL    = 087h
kEOL    = 088h
kCUSTM  = 093h
kF1 = 0C2h
kF2 = 0C3h
kF3 = 0C4h
kF4 = 0C5h
kF5 = 0C6h
kF6 = 0C7h
kF7 = 0C8h
kF8 = 0C9h
kF9 = 0CAh
kF10    =     0CBh
kGRAPH  = 0FFh

; START LISTING AGIAN
.LIST
