#ifndef __OFF_C
#define __OFF_C

/* Turn your calc off

   Small-C library, by Henk Poley (hpoley@dds.nl)
   (---no www addres---)

   Synopsis:
      off()

   Description:
      Turn your calc off. 

   Example:
      off()

   Output:
      Calc turned off

   Notes:
      o This was a comment for the old routine:
        I didn't test this routine. Because the VirtualTi doesn't
        emulate the hardware directly, which means that it can't be
        turned off by a calc program. But I think it definitely should
        work. I got it directly from Asmguru.

      o This was a comment for the old routine:
        Shouldn't there be somewhere a 'halt' in the code. Or am
        I wrong?

      o This is what Ion1.6 has to say about it.
        ; Turn off the calculator
        turnOff:
	        ld	a,1
	        out	(3),a
	        halt
                jr	pmain3

	(pmain3 is a point in the main routine of Ion.
        I think that when you write to the screen it will automagicaly
        turn on again. So you should do a write to be shure.)
*/

off()
{
#asm
; CALCOFF.ASM  v1.0 for the TI-82
; Ported from the TI-83 by Matt A.
; Turns your ti-82 calculator off!

        DI                 ; disable interrupts
        LD A,001H
        OUT (003H),A       ; turn off screen
        LD A,000H
        OUT (004H),A
        EX AF,AF'
        EXX
        EI                 ; enable interrupts
#endasm
}


/* The ones from the TI83, I think they SHOULD work, bu I'd
   better be safe.
off()
 {
 #asm
; Thanx for Jimmy Mardell and Florent Dhordain for this teacher key routine!

	ld	a,2		;
	out	($10),a		; display off
	ld	a,1		;
	out	(3),a		; enable only [ON] interrupt and turn
;				; LCD driver into standby mode
	halt			; wait 'til [ON] keypress
	ld	a,%1011		;
	out	(3),a		; enable [ON] interrupt and periodic
				; int(erupt???). Turn on LCD driver
	ld	a,3		;
	out	($10),a		; display on
 #endasm
 }

off()
 {
 #asm
	;This one seems to be the same as the one for the TI82...

	di			; disable interrupts

	ld	a,1		; a=1
	out	(3),a		; turn off screen

	ld	a,0		; a=0
	out	(4),a		; ? turn on screen ?

	ex	af,af'		;Can somebody say my what
	exx			;these are needed for???

	ei			; enable interrupts
 #endasm
 }
*/
#endif