#ifndef __EXTRA_C
#define __EXTRA_C

/* Extra TI Commands
   Other commands that are not in TIxx.h, but may become if they are 
   very usefull

   M = Macro

	Function	Description
--------------------------------------------------------------------------
	rand()		Returns a 8-bit random number
			0 to 255 / -127 to 127

	getky()		Doesn't wait till a key is pressed

	disp_int()	Display an int (_dispHL).
			...Not tested...

M	dispcur		Make the cursor visible
M	hidecur		Make the cursor invisible

M	make_cur_flash	The cursor is flashing
M	make_cur_stop_flash  The cursor stops flashing

M	disp_axis	Display the x,y-axis on the graphscreen
M	hide_axis	Remove the x,y-axis from the graphscreen

M	disp_2nd_mode	Display the 2ND-mode cursor
M	hide_2nd_mode	Hide	...

M	disp_alpha_mode	Display the Alpha-mode cursor
M	hide_alpha_mode Hide	...

M	disp_alpha_lock_mode	Display the Alpha-lock cursor
M	hide_alpha_lock_mode	Hide	...
--------------------------------------------------------------------------
*/

rand()
{
#asm
   call _RANDOM
   ld  l,a
   xor a
   ld  h,a
#endasm
}

getky()
{
#asm
;	routine that works similar to "get_key" on the 82
	call	_ZEROOOP1
	call	_GetK
	call	_OP2TOOP1
	call	_CONVOP1
	ld	l,e
	ld	h,0
#endasm
}

disp_int(c) int c;
{
#asm
	call	_dispHL
#endasm
}


#define dispcur		asm("\tset\tcurOn,(IY+curFlags)\t\t; show cursor")
#define hidecur 	asm("\tres\tcurOn,(IY+curFlags)\t\t; hide cursor")

#define make_cur_flash	asm(\tset\tcurAble,(IY+curFlags)\t\t; flash cursor")
#define make_cur_stop_flash asm(\tset\tcurAble,(IY+curFlags)\t\t; stop flashing the cursor")

#define disp_axis	asm("\tres\tgrfnoaxis,(IY+grfdbflags)\t\t; display axis")
#define hide_axis	asm("\tset\tgrfnoaxis,(IY+grfdbflags)\t\t; don't display axis")

#define disp_2nd_mode	asm("\tset\tshift2nd,(IY+shiftflags)\t\t; 2ND mode is on")
#define hide_2nd_mode	asm("\tres\tshift2nd,(IY+shiftflags)\t\t; 2ND mode is off")

#define disp_alpha_mode	asm("\tset\tshiftAlpha,(IY+shiftflags)\t\t; Alpha mode is on")
#define hide_alpha_mode	asm("\tres\tshiftAlpha,(IY+shiftflags)\t\t; Alpha mode is off")

#define disp_alpha_lock_mode asm("\tset\tshiftALock,(IY+shiftflags)\t\t; Alpha-lock mode is on")
#define hide_alpha_lock_mode asm("\tres\tshiftALock,(IY+shiftflags)\t\t; Alpha-lock mode is off")


#endif

