#ifndef _PICTURESTORE_C
#define _PICTURESTORE_C

/* Small c library, by Henk Poley (Hpoley@DDS.nl)
   (-- no WWW adress --)

   Synopsis:
      stopic(pic)
      rclpic(pic)

   Description:
      store/recall a picture from/to the graphic backup buffer

   Example:
      stopic(1)
      rclpic(0)

   Notes:
      o At the moment the routines don't return NULL if an error
        occured. I know, it's not C conform but it is smaller that way.
        And there ar almost no possible errors

      o Well, what about having less than 756 bytes of memory. Whoops
*/

#endif /* _xxx_C LOADED */
stopic(pic) char pic;
 {
 #asm
#define			PICTOBJ		  07h
#define			_createpict	4482h

	call	_ZEROOOP1	; Clean things up in OP1 (needed?)

	ld	hl,2
	add	hl,sp
	ld	a,(hl)

	dec	a		; A = A - 1
	jr	M,_stopic_0
	ld	a,9
_stopic_0:


; You want to know why, hh? Well see:
; 0 = Pic1, 1 = Pic2, ..., 9 = Pic0

	ld	(OP1+2),a	; OP1 = A
	ld	a,TVARPICT	; Token of 'Pic' (60h)
	ld	(OP1+1),a	
	ld	a,PICTOBJ	; ????
	ld	(OP1),a

; Okay, the state a this moment:
;  OP1 = picobj, tvarpic, input - 1
;  OP1 = 07h, 60h, input - 1 

	call	_CHKFINDSYM	; Check to see if the picture exists
	call	c,_createpict	; If not exist, create Pic
				; DOES _createpict RETURN ANY ERROR
				; FLAGS ???
;???	ret	c		;???
	inc	de		; skip 1st length byte
	inc	de		; skip 2nd length byte
	ld	hl,PLOTSSCREEN	; data to copy (the buffer)
	ld	bc,756		; number of bytes copy (picture size)
	ldir			; copy it!
 #endasm
 }

rclpic(pic) char pic;
 {
 #asm
#define			PICTOBJ		07h

	call	_ZEROOOP1	; Clean things up in OP1 (needed?)

	ld	hl,2
	add	hl,sp
	ld	a,(hl)

	dec	a		; A = A - 1

	dec	a		; A = A - 1
	jr	M,_rclpic_0
	ld	a,9
_rclpic_0:

; You want to know why, hh? Well see:
; 0 = Pic1, 1 = Pic2, ..., 9 = Pic0

	ld	(OP1+2),a	; OP1 = 'X' - 1
	ld	a,TVARPICT	; Token of 'Pic' (60h)
	ld	(OP1+1),a	
	ld	a,PICTOBJ	; ????
	ld	(OP1),a

; Okay, the state a this moment:
;  OP1 = picobj, tvarpic, input - 1
;  OP1 = 07h, 60h, input - 1 

	call	_CHKFINDSYM	; Check to see if the picture exists
	ret	c		; if(error), quit
				;
	ex	de,hl		; HL = pointer to PicX
				;
	inc	hl		; First 2 bytes of picture contain
	inc	hl		;  meaningless garbage (?? size ??)
				;
	ld	de,PLOTSSCREEN	; Adress to copy to.
	ld	bc,756		; Number of bytes to be copied
				;  (the size of the graph)
	ldir			; Do the copying
 #endasm
 }