#ifndef __WAITKEY__
#define __WAITKEY__

/* waits till a certain key is pressed

   Small-C library, by Henk Poley (hpoley@dds.nl)
   (---no www addres---)

   Synopsis:
      waitkey(char key)

   Description:
      Waits till a certain key is pressed

   Example:
      Waitkey(kUp)

   Output:
      waits till kUp (key up, keypad up) is pressed

   Notes:
      o You can use this as the PAUSE command in BASIC, the use
        waitkey(kEnter).
*/

waitkey(key) char key;
{
#asm
	ld	hl,2
	ld	hl,sp
	ld	b,(hl)		; What is the key we are waiting for?
waitkeyloop:
	call	_getkey		; Wait till 'any key' is pressed
	cp	b		; Is it 'the' key ?
	jr	nz,waitkeyloop	; If not, wait again.
				;  else 'fall trough' and return to
				;  the program you came from.
#endasm
}
#endif /* Waitkey routine loaded */