#ifndef MENU_C
#define MENU_C

/* Small c library, by Jeremy Dewey (jxd45@po.cwru.edu)
   http://www.seashellinc.com/jdewey

   Synopsis:
      menu(char* str1, char* str2, char* str3, char* str4, char* str5)

   Description:
      Displays a standard TI-85 menu using the given strings as menu
      items.

   Example: 
      menu("File", "Edit", "View","","Help");

   Notes:
      o Do not call this function with NULL pointers. If you desire an
        empty menu item, pass in a pointer to an empty string (i.e. "")
      o Be sure that graphpage() has been called.

        NOTE OF PORTER: ???graphpage()???
			Henk Poley


; Date:     Thu, 16 May 1996 00:10:42 -0400
; From:     Andy Selle  [aselle@mat.net]
; Subject:  LZ: Menu Generation
;
; Here is the code I wrote for drawing menus.  You just substitute the
; f1,f2,f3,f4, and f5 strings at the end for the desired choice and set
; the key loop to recognize these and take appropriate action.
; Here it is:
;
; The menu is drawn by calling the DrawMenu routine (simple enough :))
;
; This is my menu drawing routine.  This is pretty crude
; but it works.  Please give me appropriate credit if you
; use this :).
;
;By Andy Selle (aselle@mat.net)
*/
#include "pixel.c"

menu(s1,s2,s3,s4,s5) char *s1,*s2,*s3,*s4,*s5; {
#asm
;
;Can anybody tel me what all the ampersands '&' are doing here?
;	Henk Poley
;
	ld	C,56		; | Top 2 lines drawn here
	call	&_hline		; |
	ld	C,55		; |
	call	&_hline		; |
	ld	b,1		; All the rest here is the dividers of
				;  the menu
	call	&_vline
	ld	b,2
	call	&_vline
	ld	b,25
	call	&_vline
	ld	b,26
	call	&_vline
	ld	b,50
	call	&_vline
	ld	b,51
	call	&_vline
	ld	b,75
	call	&_vline
	ld	b,76
	call	&_vline
	ld	b,100
	call	&_vline
	ld	b,101
	call	&_vline
	ld	b,125
	call	&_vline
	ld	b,126
	call	&_vline
; NOW DISPLAY TEXT
	ld	hl,$3904	; X=4 Y=57
	ld	($8333),hl
	ld	hl,10
	add	hl,sp
	call	LD_HL_MHL
	call	D_ZM_STR	; The F1 choice on the menu
	ld	hl,$391C	; X=28 Y=57
	ld	($8333),hl
	ld	hl,8
	add	hl,sp
	call	LD_HL_MHL
	call	D_ZM_STR	; The F2 Choice on the Menu
	ld	hl,$3935	; X=53 Y=57
	ld	($8333),hl
	ld	hl,6
	add	hl,sp
	call	LD_HL_MHL
	call	D_ZM_STR	; The F3 Choice on the menu
	ld	hl,$394E	; X=78 Y=57
	ld	($8333),hl
	ld	hl,4
	add	hl,sp
	call	LD_HL_MHL
	call	D_ZM_STR	; The F4 Choice on the menu
	ld	hl,$3967	; X=103 Y=57
	ld	($8333),hl
	ld	hl,2
	add	hl,sp
	call	LD_HL_MHL
	call	D_ZM_STR	; The F5 Choice on the menu
	ret

_hline: ; Draws a Horizontal Line at C=Y Coordinate
	ld	B,126
_hlinelp:
	push	bc
	ld	hl,1
	push	hl
	call	pixel
	pop	bc
	pop	bc
	DJNZ	_hlinelp
	ret
_vline: ; Draws a Vertical Line at C=X Coordinate
	ld	c,63
_vlinelp:
	push	bc
	ld	hl,1
	push	hl
	call	pixel
	pop	bc
	pop	bc
	dec	c
	ld	a,c
	cp	54
	jr	nz,_vlinelp
	ret
#endasm
}

#endif