#ifndef __GETASC_C
#define __GETASC_C

/* Found this marvelous routine in the...
	'z88 Development Kit'
   which actualy has some rudimentary TI86
   support. Hmmmmm... maybe we have to take
   a look there.

   By the way, I 'renamed' the routine.

	Henk Poley
 */


getasci()
 {
 #asm
;
;	TI86 Routines
;
;	fgetc_cons() Wait for keypress
;
;	Stefano Bodrato - 9/5/2000
;
;

;		XLIB	fgetc_cons	; some stuff from their compiler

fgetc_cons:
		halt		; Power saving
		call	$55AA	; get key

		cp	6	; was it ENTER ?
		jr	nz,noenter
		ld	a,13
		jr	setout
noenter:

; Numbers. (XZ81 has the same number coding !)
		cp	28	; Between 0 and 9 ?
		jr	c,isntnum
		cp	38
		jr	nc,isntnum
		add	a,20	; Ok, re-code to the ASCII charset
		jr	setout
isntnum:
		cp	$28	; Between A and Z ?
		jr	c,isntupper
		cp	$42
		jr	nc,isntupper
		add	a,25	; Ok, re-code to the ASCII charset
		jr	setout
isntupper:
		cp	$42	; Between a and z ?
		jr	c,isntlower
		cp	$5C
		jr	nc,isntlower
		dec	a	; Ok, re-code to the ASCII charset
		jr	setout
isntlower:

		ld	hl,TiKeyTab
symloop:
		cp	(hl)
		jr	z,chfound
		inc	hl
		inc	hl
		push	af
		xor	a
		or	(hl)
		jr	z,isntsym
		pop	af
		jr	symloop
chfound:
		inc	hl
		ld	a,(hl)
		jr	setout
isntsym:
		pop	af

setout:
		ld	l,a
		ld	h,0
		ret


TiKeyTab:
	.db	1	;kRight
	.db	9
	.db	2	;kLeft
	.db	8
	.db	3	;kUp
	.db	11
	.db	4	;kDown
	.db	10

;kClear	equ	008h
;kDel	equ	009h
;kIns	equ	00Ah
;kNext	equ	00Bh

	.db	5
	.db	':'
	.db	6
	.db	13	; ENTER
	.db	7	; EXIT..
	.db	27	; ..mapped to ESC
	.db	$0C
	.db	'+'
	.db	$0D
	.db	'-'
	.db	$0E
	.db	'*'
	.db	$0F
	.db	'/'
	.db	$10
	.db	'^'
	.db	$11
	.db	'('
	.db	$12
	.db	')'
	.db	$13
	.db	'['
	.db	$14
	.db	']'
	.db	$15
	.db	'='
	.db	$18
	.db	','
	.db	$1B
	.db	'.'
	.db	$27
	.db	' '

;kCapA	equ	028h
;..
;kCapZ	equ	041h
;ka	equ	042h
;..
;kz	equ	05Bh

;kStore	equ	016h
;kRecall	equ	017h
;kAng	equ	019h
;kChs	equ	01Ah
;kEE	equ	026h
;kVarx	equ	05Ch
;kAns	equ	05Dh
;kPi	equ	05Eh
;kInv	equ	05Fh
;kSin	equ	060h
;kASin	equ	061h
;kCos	equ	062h
;kACos	equ	063h
;kTan	equ	064h
;kATan	equ	065h
;kSquare	equ	066h
;kSqrt	equ	067h
;kLn	equ	068h
;kExp	equ	069h
;kLog	equ	06Ah
;kALog	equ	06Bh
;kMath	equ	06Ch
;kCplx	equ	06Dh
;kString	equ	06Eh
;kTest	equ	06Fh
;kConv	equ	070h
;kChar	equ	071h
;kBase	equ	072h
;kCustom	equ	073h
;kVars	equ	074h
;kCatalog	equ	075h
;kQuit	equ	076h
;kLastEnt	equ	077h
;kLinkIO	equ	078h
;kMem	equ	079h
;kList	equ	07Ah
;kVector	equ	07Bh
;kConst	equ	07Ch
;kMatrix	equ	07Dh
;kPoly	equ	07Eh
;kSimult	equ	07Fh
;kStat	equ	080h
;kGrMenu	equ	081h
;kMode	equ	082h
;kPrgm	equ	083h
;kCalcu	equ	084h
;kSolver	equ	085h
;kTable	equ	086h		; new key added for LEO (?what?)
;kBOL	equ	087h
;kEOL	equ	088h
;kCUSTM	equ	093h
;kF1	equ	0C2h
;..
;kF10    equ     0CBh
;kGRAPH	equ	0FFh

	.db	0
 #endasm
 }
#endif