#ifndef __BEEP_C
#define __BEEP_C

/* I dont really know if this will work on the TI83/86,
   but here is a 'beep' routine.
	greetz,
	Henk Poley (HPoley@DDS.nl)
   (It doesn't seem to do any romcalls, but if the 'out'
   values are correct???)

   I hope this is a good explanation of it, I found it 
   together with another routine. They don't seem to 
   have much common. But give it a try and report to
   us...

;The tone and length values relate to each other like this:
;
;The tone value goes to a wait counter between every set_low and set_high
;and the length value is used to determine how many loops will be run
;(a loop consists of one set_low and one set_high).
;
;I recommend using tones 256...14336 (with step of 256), they have been tested
;to sound like something... (tone=key scancode*256 :)
;Length should be longer on higher tones (smaller int tone values).

   ----------------------------------------------------
   Small c library, by Jeremy Dewey (jxd45@po.cwru.edu)
   http://www.seashellinc.com/jdewey

   Synopsis:
      beep(int tone, int length)

   Description:
      Generates a tone of the given freq and duration

   Example: 
      beep(560, 200)

   Notes:
      o I have not tested this function, as I have no speaker on my TI

      o I've documented it a little, but I you can say more of it,
        please do so.

; Date:     Sun, 24 Mar 1996 10:00:35
; From:     Eric Linenberg  [ELinenberg@gnn.com]
; Subject:  LZ: SOUND routine

; This message comes from the List-ZShell mailing list:

; Do you want sound in your ZShell games
; THEN*USE*THIS*ROUTINE*

; reasons why you should use this:
; 1.sound is cool
; 2.takes up almost NO MEMORY
; 3.games are more fun
; 4.Breakout will KICK ASS

; reasons why you shouldn't use this:
; 1.if you want a song get my next routine
; 2.NONE

;ld de with length 1-65535
;ld hl with tone   1-65535
;then CALL_(beep)
*/

beep(tone, length) int tone, length; {
#asm
	ld	hl,2
	add	hl,sp
	call	LD_HL_MHL	; hl now contains length
	ex	de,hl		; de now contains length

	ld	hl,4
	add	hl,sp
	call	LD_HL_MHL	; hl now contains tone

   	di			; disable interrupts
_beepst:
;set_low
   	ld  	b,%11111100	; b = 252
   	ld  	c,7		; use port 7
   	out  	(c),b		; output 252 thru port 7
  	push 	hl		; save hl
_bpd1:
   	dec  	hl
   	ld   	a,l
   	or	h
   	jr   	nz,_bpd1
   	pop	hl		; get saved hl
;set_high:
   	ld  	b,%11000000	; b = 192
   	ld  	c,7       
   	out 	(c),b		; output 192 thru port 7
        push 	hl		; save hl
_bpd2:
   	dec  	hl
    	ld   	a,l
    	or   	h
    	jr   	nz,_bpd2
    	pop	hl		; get saved hl
	dec 	de
   	ld	a,d
   	cp	0
   	jr      nz,_beepst
   	ei			; enable interrupts
#endasm
}
#endif
