#ifndef __SHLSORT_C
#define __SHLSORT_C

/* Sort a string

   Small-C library, by Henk Poley (hpoley@dds.nl)
   (---no www addres---)

   Synopsis:
      shellsort(int v[], int n)

   Description:
      It will sort the string v[], for maximal n characters.

   Example:
      bla = shellsort("building",8)

   Output:
      bla =  "bdgliinu"

   Notes:
      o I didn't test this routine (hmmm).

      o This routine is ripped off the CCGB compiler for the Gameboy.

*/

/* ************************************************************ */
/* Shell sort of string v[0] .... v[n-1] into increasing order */
/* 'int v[]' is actually 'char *v[]' */

shellsort(v[],n) int v[], int n;
{
  int gap, i, j;
  char *temp;

  for(gap = n/2; gap > 0; gap = gap / 2)
    for(i = gap; i < n; i++)
      for (j = i - gap; j >= 0; j = j - gap) {
	if(strcmp(v[j], v[j+gap]) <= 0)
	  break;
	temp = v[j];
	v[j] = v[j + gap];
	v[j + gap] = temp;
      }
}
#endif