/* TI-82 Definitions File */
/* These routines are NOT tested...
   They will PROBABLY work. But I can't say that there are no 
   bugs in this code. So please remove any bugs if you find them
*/

#ifndef __TILOADED__
#define __TILOADED__

/* So TASM knows what calc it is */
#asm
#define __TI82__
#define __CrASH__
#endasm

/* some default defines
   Taken from another Small-C compiler, so maybe
   a bit out off the order here.*/
/* #define ERR   (-2)  .. return value for errors */
/* #define EOF   (-1)  .. return value for end-of-file */
#define FILE  char  /* supports "FILE *fp[x];" declarations */
#define YES      1  /* true */
#define NO       0  /* false */
#define TRUE     1
#define FALSE    0
#define NULL     0  /* zero */
#define CR      13  /* ASCII carriage return */
#define LF      10  /* ASCII line feed */
#define BELL     7  /* ASCII bell */
#define SPACE  ' '  /* ASCII space */
#define NEWLINE LF  /* Small C newline character */

/* Macros

Macro Name	Description
----------------------------------------------------------------------------
clrscrn		Clears The Text form the Screen	(...that is whipe LCD ???...)
clrlcd		Clears the hole LCD screen	(...the same as above...)
indicatoroff	This turns the annoying run indicator off (somebody say me how to do this)
indicatoron	This turns the annoying run indicator on  (somebody say me how to do this)
displaygraph	This function displays whatever graphing equations are stored
		in the calculator.			(somebody say me how to do this)
nl		This function makes a new line on the screen like a \n in
		Most C programing.			(this one should work...)

screencopy	This command copies the ti backbuffer to the screen (should work too)
clearbuffer	This command clears the ti backbuffer	(what call should I use?)
*/

#define clrscrn		asm("\tROM_CALL(CLEARLCD)\n")
#define clrlcd		asm("\tROM_CALL(CLEARLCD)\n")

#define indicatoroff	asm("\tRES 0,(IY+12)\n")
#define indicatoron	asm("\tSET 0,(IY+12)\n")

/* Or should it be: (see "82-rom.txt") (this on is for ROM version 19)
#define indicatoroff	asm("\tcall 3932\n")
#define indicatoron	asm("\tcall 394A\n")			  
*/

/*
#define displaygraph	asm("\tcall\t_PDspGrph\n");
*/

#define nl		asm("\tROM_CALL(NEXT_LINE)\n");

#define screencopy	asm("\CALL(CR_GRBCopy)\n");

/* Or should I use this one ??? It say "sslllloowwwww" in the docs.
#define screencopy	asm("\ROM_CALL(DISP_GRAPH)\n"); 
*/

/* What call should I use ???
#define clearbuffer	asm("\tcall\t_GRBUFCLR\n");
*/

/* Pixel Definitions

These are used when calling functions like line, pixel, and Box

PT_OFF		Turns the pixel/pixels off
PT_ON		Turns the pixel/pixels on
PT_CHG		Inverts the pixel/pixels

*/

#define PT_OFF		0x00
#define PT_ON		0x01
#define PT_CHG		0x02

/* Basic TI Commands

	Function	Description
--------------------------------------------------------------------------
	setxy(x,y)	This function moves the text cursor to the specified
			(x,y) location		(Should be the good mem positions)

	putm(c)		Puts a character on the current location, but does NOT
			update the cursor position	(which ROM_CALL() ???)

	putc(c)		Puts the character on the current location and move the
			cursor over one space		(which ROM_CALL() ???)

	puts(str)	This command puts a specified string at the current
			cursor location and moves the cursor location up
							(this one should work)

	getkey()	This command waits for a key or the APD register
			to clear. The calculator will be in low power stand-
			by during this process. It returns a value refer
			to the k* table.
				(I've heard that the TI82 getkey is different from
				 tho TI83 one. How should I adept them to make the
				 the same?)
				(should I use CR_KHAND or not?)
*/

setxy(x,y) char x, y; {
#asm
	ld	hl,2
	add	hl,sp
	ld	a,(hl)
	ld	(CURSOR_ROW),a
	inc	hl
	inc	hl
	ld	a,(hl)
	ld	(CURSOR_COL),a
#endasm
}

/*
putm(c) char c; {
#asm
	ld	hl,2
	add	hl,sp
	ld	a,(hl)
	call	_putmap
#endasm
}
*/

/*
putc(c) char c; {
#asm
	ld	hl,2
	add	hl,sp
	ld	a,(hl)
	call	_putc
#endasm
}
*/

puts(str)
char* str;
{
#asm
	ld	hl,2
	add	hl,sp
	ld	a,(hl)
	inc	hl
	ld	h,(hl)
	ld	l,a
; At this point HL is pointer to what we want
;	To add support for \n we will not be using "ROM_CALL(D_ZT_STR)"
;	ROM_CALL(D_ZT_STR)
puts_top:
	ld	a,(hl)
	and	a
	jr	z,puts_end
	cp	10
	jr	z, puts_nl
	ROM_CALL(TX_CHARPUT)
	inc	hl
	jr	puts_top
puts_nl:
	ROM_CALL(NEXT_LINE)
	inc	hl
	jr	puts_top
puts_end:
#endasm
}

getkey()
{
#asm
	call	CR_KHAND	;WAITS for a key to be pressed
	ld	l,a
	ld	h,0
#endasm
}

/* These are the values that would be returned by getkey() */
/* Need to be sorted! */
/* I hope I got the good ones...
   I think the "G_xxxxx" equates are for
   the getkey values, am I right?
   And "K_xxxx" ones for CR_KHAND

   The ones that I couldn't translate directly
   have "K_" in front of them

   I think I'm missing necesairy keys like:
   kSpace, ...
*/


#define	kRight		1 /* RIGHT     RIGHT	*/
#define	kLeft		2 /* LEFT      LEFT	*/
#define	kUp		3 /* UP        UP	*/
#define	kDown		4 /* DOWN      DOWN	*/
#define	kEnter		5 /* ENTER     ENTER	*/
#define	kClear		6 /* CLEAR     CLEAR	*/
#define	kDEL		7 /* DEL       DEL	*/
#define	kINS		8 /* DEL       INS	*/
#define	kRecall		9 /* STO>      RCL	*/

#define	K_ENTRY		10 /* ENTER     ENTRY	*/ /* no return-value on TI83/86 */

#define	kBOL		11 /* LEFT      BOL	*/
#define	kEOL 		12 /* RIGHT     EOL	*/
#define	kPrgm		45 /* PRGM      PRGM	*/
#define	kZOOM		46 /* ZOOM      ZOOM	*/
#define	kDRAW		47 /* PRGM      DRAW	*/
#define	kPLOT		48 /* Y=        STAT PLOT */
#define	kMATH		49 /* MATH      MATH	*/
#define	kTEST		50 /* MATH      TEST	*/
#define	kVARS		52 /* VARS      VARS	*/
#define	kMem		53 /* +         MEM	*/
#define	kMATRIX		54 /* MATRIX    MATRIX	*/
#define	kSTAT		55 /* STAT      STAT	*/

#define	K_Y-VARS	56 /* VARS      Y-VARS	*/ /* is this kYEQU ? */

#define	kANGLE		57 /* MATRIX    ANGLE	*/
#define	kLIST		58 /* STAT      LIST	*/
#define	kCALC		59 /* TRACE     CALC	*/
#define	kQuit		64 /* MODE      QUIT	*/
#define kExit		64 /* For support against the 86 */
#define	kLinkIO		65 /* X,T,theta LINK	*/
#define	kGRAPH		69 /* GRAPH     GRAPH	*/
#define	kMODE		70 /* MODE      MODE	*/
#define	kWINDOW		73 /* WINDOW    WINDOW	*/

#define	K_YEDIT 	74 /* Y=        Y=	*/ /* or is this kYEQU ? */

#define	kTABLE		75 /* GRAPH     TABLE	*/
#define	kTBLSET		76 /* WINDOW    TblSet	*/
#define	kTRACE		93 /* TRACE     TRACE	*/
#define	kAdd		129 /* +         +	*/
#define	kSub		130 /* -         -	*/
#define	kMul		131 /* *         *	*/
#define	kDiv		132 /* /         /	*/
#define	kExpon		133 /* ^         ^	*/
#define	kLParen		134 /* (         (	*/
#define	kRParen		135 /* )         )	*/
#define	kLBRACK		136 /* *         [	*/
#define	kRBRACK		137 /* -         ]	*/
#define	kStore 		139 /* STO>      STO>	*/
#define	kCOMMA		140 /* ,         ,	*/

#define	K_NEG 		141 /* (-)       (-)	*/ /* is this kChs ? */
#define	K_PERIOD	142 /* .         .	*/ /* is this kDecPnt ? */

#define	k0   		143 /* 0         0	*/
#define	k1   		144 /* 1         1	*/
#define	k2   		145 /* 2         2	*/
#define	k3   		146 /* 3         3	*/
#define	k4   		147 /* 4         4	*/
#define	k5   		148 /* 5         5	*/
#define	k6   		149 /* 6         6	*/
#define	k7   		150 /* 7         7	*/
#define	k8   		151 /* 8         8	*/
#define	k9   		152 /* 9         9	*/
#define	kEE  		153 /* ,         EE	*/
#define	K_SEMI		154 /* 0         ;	*/
#define	kCapA  		155 /* MATH      A	*/
#define	kCapB   	156 /* MATRIX    B	*/
#define	kCapC  		157 /* PRGM      C	*/
#define	kCapD  		158 /* X^-1      D	*/
#define	kCapE  		159 /* SIN       E	*/
#define	kCapF  		160 /* COS       F	*/
#define	kCapG  		161 /* TAN       G	*/
#define	kCapH  		162 /* ^         H	*/
#define	kCapI  		163 /* X^2       I	*/
#define	kCapJ  		164 /* ,         J	*/
#define	kCapK  		165 /* (         K	*/
#define	kCapL  		166 /* )         L	*/
#define	kCapM   	167 /* /         M	*/
#define	kCapN	 	168 /* LOG       N	*/
#define	kCapO		169 /* 7         O	*/
#define	kCapP  		170 /* 8         P	*/
#define	kCapQ  		171 /* 9         Q	*/
#define	kCapR  		172 /* *         R	*/
#define	kCapS  		173 /* LN        S	*/
#define	kCapT  		174 /* 4         T	*/
#define	kCapU  		175 /* 5         U	*/
#define	kCapV  		176 /* 6         V	*/
#define	kCapW  		177 /* -         W	*/
#define	kCapX  		178 /* STO>      X	*/
#define	kCapY  		179 /* 1         Y	*/
#define	kCapZ  		180 /* 2         Z	*/

#define	kVarx 		181 /* X,T,theta X,T,theta */ /* at least I think it is... */

#define	kPi  		182 /* ^         Pi	*/
#define	kINV		183 /* X^-1      X^-1	*/
#define	kSin 		184 /* SIN       SIN	*/
#define	kASin		185 /* SIN       SIN^-1	*/
#define	kCos 		186 /* COS       COS	*/
#define	kACos		187 /* COS       COS^-1	*/
#define	kTan 		188 /* TAN       TAN	*/
#define	kATan		189 /* TAN       TAN^-1	*/
#define	kSQUARE		190 /* X^2       X^2	*/
#define	kSQRT		191 /* X^2       SQRT	*/
#define	kLN		192 /* LN        LN	*/
#define	kEXP		193 /* LN        e^X	*/
#define	kLOG		194 /* LOG       LOG	*/
#define	kALOG		195 /* LOG       10^X	*/ 
#define	kAns		198 /* (-)       ANS	*/

#define	K_COLON		199 /* .         :	*/ /* is this kColon ? */

#define	kQUEST		203 /* (-)       ?	*/
#define	kQUOTE		204 /* +         "	*/
#define	kTHETA		205 /* 3         THETA	*/
#define	kLBRACE		237 /* (         {	*/
#define	kRBRACE		238 /* )         }	*/

#define	K_ABS 		244 /* X^-1      ABS	*/ /* not known on TI83/86 */

#define	kL1A		245 /* 1         L1	*/
#define	kL2A		246 /* 2         L2	*/
#define	kL3A		247 /* 3         L3	*/
#define	kL4A		248 /* 4         L4	*/
#define	kL5A		249 /* 5         L5	*/
#define	kL6A		250 /* 6         L6	*/

#define	K_n		251 /* 9         n	*/
#define	K_Vn1 		252 /* 8         Vn-1	*/
#define	K_Un1 		253 /* 7         Un-1	*/

#endif /* __TILOADED__ */