#ifndef DISP_DEC_C
#define DISP_DEC_C

/* Small c library, by Jeremy Dewey (jxd45@po.cwru.edu)
   http://www.seashellinc.com/jdewey

   Synopsis:
      disp_char(char) - display a char at the current location
      disp_int(int) - display an int
      disp_sint(int) - display a signed int

   Description:
      These functions all use menu-style text

   Example:
      disp_char(5);
      disp_int(4563);
      disp_sint(-13423);

   Notes:
      o This is based on the source code from displib
        (thanks to Sam Davies and Andreas Ess) 

*/

disp_char(c) char c; {
#asm
   ld  hl,2
   add hl,sp
   ld  a,(hl)
   call &_D_A_DEC
#endasm
}

disp_int(i) char i; {
#asm
   ld  hl,2
   add hl,sp
   call LD_HL_MHL
   call &_D_HL_DEC
#endasm
}

disp_sint(si) char si; {
#asm
   ld  hl,2
   add hl,sp
   call LD_HL_MHL
   call &_D_HL_SIGN
#endasm
}

/* Actual source code */

#asm
_D_HL_SIGN:
	bit	7, H
	jr	z, R_SP
	ld	A, '-'
	call	M_CHARPUT
	ex	DE, HL
	ld	HL, 0
	or	A
	sbc	HL, DE
	jr	R_SP

_D_A_DEC:
	ld	H, 0
	ld	L, A
	ld	A, (CURSOR_X)
	sub	8
	ld	(CURSOR_X), A
	jr	R_SP

_D_HL_DEC:
R_SP:	ld   	DE, _StringPlace+4
	ld   	B, 5
_ConvLoop:
	call 	UNPACK_HL
	add  	A, '0'
	ld   	(DE), A
	dec  	DE
	djnz 	_ConvLoop
	ld   	HL, &_StringPlace
	ld   	B, 4
_Compare0:
	ld   	A, (hl)
	cp   	'0'
	jr   	nz, _PrintString
	inc  	hl
	ld	A, (CURSOR_X)
	add	A, 4
	ld	(CURSOR_X), A
	djnz 	_Compare0

_PrintString:
   call  D_ZM_STR
	ret

_StringPlace:
.db 0,0,0,0,0,0
#endasm

#endif
