#ifndef PIXEL_C
#define PIXEL_C

/* Small c library, by Jeremy Dewey (jxd45@po.cwru.edu)
   http://www.seashellinc.com/jdewey

   Synopsis:
      putpixel(x,y) - makes the point at (x,y) black
      delpixel(x,y) - makes the point at (x,y) white
      chgpixel(x,y) - reverses the color of the point at (x,y)

   Notes:
      o The origin is the upper-left corner

*/

putpixel(x,y) char x, y; {
#asm
   ld hl,2
   add hl,sp
   ld c,(hl)
   inc hl
   inc hl
   ld b,(hl)
_putpix:
   call &_find_pixel
   or   (HL)
   ld   (HL),A
#endasm
}

delpixel(x,y) char x, y; {
#asm
   ld hl,2
   add hl,sp
   ld c,(hl)
   inc hl
   inc hl
   ld b,(hl)
_delpix:
	call &_find_pixel
	cpl			;complement = xor 255
   and  (HL)
   ld   (HL),A
#endasm
}

chgpixel(x,y) char x, y; {
#asm
   ld hl,2
   add hl,sp
   ld c,(hl)
   inc hl
   inc hl
   ld b,(hl)
_chgpix:
   call &_find_pixel
   xor  (HL)
   ld   (HL),A
#endasm
}

// This makes the origin in the upper-left corner
#asm
_find_pixel:
   push bc
   ld  a,63
   sub c
   ld  c,a
   call FIND_PIXEL
   ld  de,$FC00
   add hl,de
   pop bc
   ret
#endasm

#endif
