#ifndef SPRITE_X_C
#define SPRITE_X_C

/* Small c library, by Chris Dannemiller (dannemiller@hotmail.com)

   Ported from the TI-85 code by:

   Jeremy Dewey (jxd45@po.cwru.edu)
   http://www.seashellinc.com/jdewey

   Synopsis:
      sprite(char* spr, char x, char y, char width, char height)

   Description:
      Draws sprite XOR style to the screen upto 8 in width at any
      height.

   Example:
      extern char my_sprite[6];   [6 lines sprite]
      sprite_xor(my_sprite, 10, 10, 7, 6);

   Notes:
      o Sprites must be stored from top down, each line beginning on
        byte boundaries. If the sprite is < 8 pixels wide, it must use
        the most significant bits to store its data.

      o See also sprite.c (sprite drawn to the screen) and sprite_t.c
        (black pixels are drawn)

*/

#ifndef SPRT_VAR
#define SPRT_VAR
#ifndef __PIXEL_C_
#include <pixel.c>
#endif
char* _spr;
char _spr_h;
#endif
sprite_xor(spr, x, y, w, h) char *spr, x, y, w, h; {
#asm
   ld   hl,10
   add  hl,sp
   call _gint
   ld   (_spr),hl    ; put sprite pointer into _spr
   ld   hl,6
   add  hl,sp
   ld   d,(hl)       ; put y into c
   ld   hl,2
   add  hl,sp
   ld   a,(hl)
   ld   (_spr_h),a   ; put height into _spr_h

_sprx_ln:
   ld   hl,8
   add  hl,sp
   ld   e,(hl)       ; put x into b
   ld   hl,4
   add  hl,sp
   ld   b,(hl)       ; put width into d
   ld   hl,(_spr)
   ld   a,(hl)
   ld   c,a          ; load line into e
_sprx_pi:
   push bc
   push de
   ld   a,c
   and  $80
   call nz,_chgpix
   pop  de
   pop  bc
   sla  c
   inc  e
   dec  b
   jr   nz,_sprx_pi
   ; any more lines?
   ld   hl,_spr_h
   dec  (hl)
   jr   z,_sprx_end
   ; prepare next line
   inc  d
   ld   hl,_spr
   inc  (hl)
   jr   _sprx_ln
_sprx_end:
#endasm
}

#endif /* SPRITE_X_C */
